--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local addon, ns = ...
local cargBags = ns.cargBags

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r * 0.45, g = playerColor.g * 0.45,b = playerColor.b * 0.45,a = 0.75}
local InkedColorsBorder = {r = playerColor.r * 0.85, g = playerColor.g * 0.85,b = playerColor.b * 0.85,a = 1}

local InkedBags = cargBags:GetImplementation("InkedBags")
local MyContainer = InkedBags:GetContainerClass()
local function CreateButtonTexture(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonEdge",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForeground:SetAllPoints(frame)
		  ButtonForeground:SetFrameLevel(1)
		  ButtonForeground:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
			edgeFile = "Interface\\AddOns\\Inked\\Graphics\\Borders\\PsychoBorder",
			edgeSize = 16,
			insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,InkedColors.a)
		ButtonForeground:SetBackdropBorderColor(InkedColorsBorder.r,InkedColorsBorder.g,InkedColorsBorder.b,InkedColorsBorder.a)
		
end
local function CreateButtonTexture2(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonEdge",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForeground:SetAllPoints(frame)
		  ButtonForeground:SetFrameLevel(2)
		  ButtonForeground:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
			edgeFile = "Interface\\AddOns\\Inked\\Graphics\\Borders\\PsychoBorder",
			edgeSize = 16,
			insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(0,0,0,0.5)
		ButtonForeground:SetBackdropBorderColor(1,1,1,0.5)
	
end

function MyContainer:OnContentsChanged()
if Inked.db.profile.UseBags == false then  return end  
	-- SortBags();
	UIErrorsFrame:UnregisterEvent('UI_ERROR_MESSAGE')
 UIErrorsFrame:Clear();
 UIErrorsFrame:Hide();
	 SetSortBagsRightToLeft(false)
	SortBags();

	local width, height = self:LayoutButtons("grid", self.Settings.Columns, 5, 10, -36)


	self:SetSize(width + 25, height + 85)
end

local function highlightFunction(button, match)
	button:SetAlpha(match and 1 or 0.1)
end
function InkedBags:ToggleBackpack()
print("yup")

end

function MyContainer:OnCreate(name, settings)
if Inked.db.profile.UseBags == false then  return end  
	self.Settings = settings
	self:SortButtons("bagSlot")

	self:EnableMouse(true)
	CreateButtonTexture(self)
	UIErrorsFrame:UnregisterEvent('UI_ERROR_MESSAGE')
	
	UIErrorsFrame:Clear();
	UIErrorsFrame:Hide();
	SetSortBagsRightToLeft(false)
	SortBags();
	
	self:SetParent(settings.Parent or InkedBags)
	self:SetFrameStrata("HIGH")

	--if(settings.Movable) then
		self:SetMovable(true)
		self:RegisterForClicks("LeftButton", "RightButton");
	    self:SetScript("OnMouseDown", function()
	    	self:ClearAllPoints() 
			self:StartMoving() 
	    end)
		self:SetScript("OnMouseUp",  self.StopMovingOrSizing)
		self:SetClampedToScreen(true)
		self:SetClampRectInsets(0, 0, 0,0)
	--end

	settings.Columns = settings.Columns or 8
	self:SetScale(settings.Scale or 1)
	-- close button
	local close = CreateFrame("Button", nil, self, "UIPanelCloseButton")
	close:SetPoint("TOPRIGHT", -2, -1)	
	close:SetScript("OnClick", function(self, ...) ToggleBackpack() UIErrorsFrame:RegisterEvent('UI_ERROR_MESSAGE') end)
	--close:GetNormalTexture():SetDesaturated(0.2)



	local infoFrame = CreateFrame("Button", nil, self)
	infoFrame:SetPoint("TOPLEFT", 10, -3)
	infoFrame:SetPoint("TOPRIGHT", -10, -3)
	infoFrame:SetHeight(32)
	
	local infoFrame2 = CreateFrame("Button", nil, self)
	infoFrame2:SetFrameLevel(2)
	infoFrame2:SetPoint("BOTTOMLEFT", 10, 5)
	infoFrame2:SetPoint("BOTTOMRIGHT", -10, 5)
	infoFrame2:SetHeight(32)
	CreateButtonTexture2(infoFrame2)
	
	local infoFrame3 = CreateFrame("Button", nil, self)
	infoFrame3:SetFrameLevel(2)
	infoFrame3:SetPoint("BOTTOMLEFT", 10, 5)
	infoFrame3:SetPoint("BOTTOMRIGHT", -10, 5)
	infoFrame3:SetHeight(32)
	
	local totalFree, freeSlots, bagFamily = 0
	for i = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
		freeSlots, bagFamily = GetContainerNumFreeSlots(i)
		if bagFamily == 0 then
			totalFree = totalFree + freeSlots
		end
	end
	
	local ClickSearch = self:SpawnPlugin("TagDisplay", "Click to Search", infoFrame)
	ClickSearch:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
	ClickSearch:SetPoint("LEFT", infoFrame, "LEFT")
	

	
	local ClickDrag = self:SpawnPlugin("TagDisplay", "Left Click and Drag", infoFrame2)
	ClickDrag:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
	ClickDrag:SetPoint("CENTER", infoFrame2, "CENTER",0,0)
	
	if(name == "Main") then
		local FreeSpace = self:SpawnPlugin("TagDisplay", "Free Space"..string.format("(%s)", totalFree), infoFrame3)
		FreeSpace:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
		FreeSpace:SetPoint("CENTER", infoFrame3, "CENTER",-150,0)
		local MainName = self:SpawnPlugin("TagDisplay", "Main", infoFrame3)
		MainName:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
		MainName:SetPoint("CENTER", infoFrame3, "CENTER",150,0)
	end
	if(name == "Bank") then
		
		local EpicsName = self:SpawnPlugin("TagDisplay", "Main Bank", infoFrame3)
		EpicsName:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
		EpicsName:SetPoint("CENTER", infoFrame3, "CENTER",200,0)
	end
	if(name == "Reagents") then
		
		local EpicsName = self:SpawnPlugin("TagDisplay", "Reagents Bank", infoFrame3)
		EpicsName:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
		EpicsName:SetPoint("CENTER", infoFrame3, "CENTER",200,0)
	end

	-- This one shows currencies, ammo and - most important - money!
	if(name == "Main") then
	local tagDisplay = self:SpawnPlugin("TagDisplay", "[currencies] [ammo] [money]", infoFrame)
	tagDisplay:SetFont(LSM:Fetch("font", Inked.db.profile.Bagfont), Inked.db.profile.BagFontSize,Inked.db.profile.BagOutline)	
	tagDisplay:SetPoint("RIGHT", infoFrame, "RIGHT", -20, 0)
	end

	local bagBar = self:SpawnPlugin("BagBar", settings.Bags)
	bagBar:SetSize(bagBar:LayoutButtons("grid", 1))
	bagBar:SetScale(1)
	bagBar.highlightFunction = highlightFunction 
	bagBar.isGlobal = nil 

	-- Bank goes right, inventory goes left
	if(name == "Bank") then
		bagBar:SetPoint("TOPLEFT", self, "TOPRIGHT", 5, -5)
	else
		bagBar:SetPoint("TOPRIGHT", self, "TOPLEFT", -5, -5)
	end

	-- Plugin: SearchBar
	-- If we specify a frame as an optional arg #2, then this frame
	-- shows the search onClick at its own place
	local search = self:SpawnPlugin("SearchBar", infoFrame)
	search.highlightFunction = highlightFunction -- same as above, only for search
	search.isGlobal = nil -- This would make the search apply to all containers instead of just this one
end